/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2016                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2015                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/



#ifndef CUBEW_VERSION_H
#define CUBEW_VERSION_H


/*-------------------------------------------------------------------------*/
/**
 *  @file  CUBEWW-version.h
 *  @brief Provides the CUBEWW package version information.
 **/
/*-------------------------------------------------------------------------*/


/// @name CUBEWW version information
/// @{

/// CUBEWW revision number
#define CUBEW_REVISION "18159"

/// CUBEWW revision number
#define CUBEW_REVISION_NUMBER 18159

/// CUBEWW revision number
#define CUBEW_REVISION_STRING CUBEW_REVISION




/// CUBEWW major version number
#define CUBEW_MAJOR   "4"

/// CUBEWW minor version number
#define CUBEW_MINOR   "4"

/// CUBEWW bugfix version number
#define CUBEW_BUGFIX   "2"

/// CUBEWW suffix
#define CUBEW_SUFFIX   ""

/// CUBEWW suffix_internally
#define CUBEW_SUFFIX_INTERNAL   

/// CUBEWW version number (<i>major</i>.<i>minor</i>)
#define CUBEW_SHORT_VERSION   CUBEW_MAJOR "." CUBEW_MINOR

/// CUBEWW full version number (<i>major</i>.<i>minor</i>.<i>bugfix</i>)
#define CUBEW_FULL_VERSION   CUBEW_SHORT_VERSION "." CUBEW_BUGFIX

/// CUBEWW version number
#define CUBEW_VERSION "4.4.2"

/// CUBEWW package name "CUBEWW"
#define CUBEW_SHORT_NAME  "CubeW"

/// CUBEWW package name "CUBEWW-4.x.1-XX"
#define CUBEW_FULL_NAME   CUBEW_SHORT_NAME "-" CUBEW_FULL_VERSION CUBEW_SUFFIX 


/// CUBEWW library interface information
#define LIBRARY_CURRENT "8"
#define LIBRARY_REVISION "2"
#define LIBRARY_AGE "1"

/// @}


#endif   // !CUBEW_VERSION_H
